POJ3126-首相选门牌

3 篇文章 0 订阅

题目:http://poj.org/problem?id=3126
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0

思路:先将素数打表,然后判断素数之间是否相邻(四位数有三位数则相邻),然后找出最初门牌号和最后的门牌号在素数表中的下标,进行BFS搜索。

#include<cstdio>
#include<queue>
#include<cstring>
#include<cmath>
#include<iostream>
using namespace std;
const int max_=10000; 
bool is_prime[max_];
int prime[max_];
int visit[max_];
int x,y;
int p=0;//记录素数个数 
struct Node{
	int x;
	int step;
};
// 素数打表
void Prime()
{
	for(int i=0;i<=max_;i++)
	{
		is_prime[i]=true;
	}
	is_prime[0]=is_prime[1]=false;
	for(int i=2;i<max_;i++)
	{
		if(is_prime[i])	
		{
			prime[p++]=i;
			for(int j=2*i;j<max_;j+=i)
			is_prime[j]=false;			
		}
	}	
} 
bool OK(int x,int y)
{
	int temp=0;
	while(x!=0)
	{
		if(x%10==y%10) temp++;
		x/=10;
		y/=10;
	}
	if(temp==3) return true;
	return false;
}
void bfs(int s,int end)
{
	memset(visit,0,sizeof(visit));
	queue<Node>Q;
	Node strat,next;
	strat.x=s; 
	strat.step=0;
	Q.push(strat);
	visit[s]=1;
	while(!Q.empty())
	{
		strat=Q.front();
		Q.pop();
		for(int i=0;i<p;i++)
		{
			if(OK(prime[strat.x],prime[i])&&!visit[i])
			{
				if(prime[i]==y)
				{
					cout<<strat.step+1<<endl;
					return;
				}
					
				visit[i]=1;
				next.x=i;
				next.step=strat.step+1;
				Q.push(next);
			}	
		}		
	}
	printf("0\n");
}
int main()
{
	Prime();
	int n,s,end;
	cin>>n;
	while(n--)
	{
		scanf("%d%d",&x,&y);
		for(int i=0;i<p;i++)
		{
			if(prime[i]==x) s=i;
			if(prime[i]==y) end=i;
		}
		if(s==end)
			cout<<"0"<<endl;
		else 
			bfs(s,end);
	}
	return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值